

#property copyright "520FX 򻯲Խ"
#property link      "http://www.520FX.com"

#property indicator_chart_window
#property  indicator_buffers 2
#property  indicator_color1  PaleVioletRed
#property  indicator_color2  DeepSkyBlue

//
//
//
//
//

extern int ProjectionPeriod  = 20;

//
//
//
//
//

double   bufferUp[];
double   bufferDn[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{DrawLogo();//Logo
   SetIndexBuffer(0,bufferUp);
   SetIndexBuffer(1,bufferDn);
         IndicatorShortName("Projection bands ("+ProjectionPeriod+")");
   return(0);
}
int deinit()
{
   DeleteLogo();//ɾLogo
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      double slopel = lrsSlope(ProjectionPeriod,PRICE_LOW ,i);
      double slopeh = lrsSlope(ProjectionPeriod,PRICE_HIGH,i);
         double max = iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i);
         double min = iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW ,i);

         for (int k=1; k<ProjectionPeriod; k++)
         {
            min = MathMin(min,iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW ,i+k)+k*slopel);
            max = MathMax(max,iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i+k)+k*slopeh);
         }
         bufferUp[i] = max;
         bufferDn[i] = min;
   }
   
   //
   //
   //
   //
   //
   
   return(0);
}


  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

double lrsSlope(int period,int appliedPrice,int shift)
{
   double sumx  = period*(period+1.0)/2.0;
   double sumx2 = period*(period+1.0)*(2*period+1.0)/6.0;
   double sumxy = 0.00;
   double sumy  = 0.00;

   int n = period;
   int i;
      for (i=0; i<period; i++,n--)
      {
         double price  = iMA(NULL,0,1,0,MODE_SMA,appliedPrice,shift+i);
                sumxy += n*price;
                sumy  +=   price;
      }        

   //
   //
   //
   //
   //
   
   double slope = 0.00;
   double top   = period*sumxy - sumx*sumy;
   double bot   = period*sumx2 - sumx*sumx;
      if (bot != 0) slope = top/bot;
   return(slope);
}
void writetext(string Labelname,string data,int x,int y,int Corner,color ColorValue,int FontSize)//ͨObjectд
{
   ObjectDelete(Labelname);
   ObjectCreate(Labelname, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Labelname, data, FontSize, "Arial", ColorValue);
   ObjectSet(Labelname, OBJPROP_CORNER, 0);
   ObjectSet(Labelname, OBJPROP_CORNER,Corner);
   ObjectSet(Labelname, OBJPROP_XDISTANCE, x);
   ObjectSet(Labelname, OBJPROP_YDISTANCE, y);
}
void DrawLogo()
{
    int Corner=2;
    int x=10;
    int y=10;
    color ColorValue=White;
    color LogoColor=Yellow;
    writetext("½","",0+x,0+y,Corner,ColorValue,10);
    for(int i=0;i<=10;i++)
     writetext("Ϻ"+i,"",9+x+i*13,0+y,Corner,ColorValue,10);
    writetext("½","",0+x+i*13+9,0+y,Corner,ColorValue,10);
    for(int j=0;j<=1;j++)
    writetext(""+j,"",0+x,14+y+j*13,Corner,ColorValue,10);
    for(j=0;j<=1;j++)
    writetext("1"+j,"",0+x+1,14+y+j*13,Corner,ColorValue,10);    
    writetext("Ͻ","",0+x,14+y+j*13,Corner,ColorValue,10);
    writetext("1","www.520FX.com",35+x,10+y,Corner,LogoColor,10);
    writetext("2","ײ",20+x,25+y,Corner,ColorValue,10);
    for(int k=0;k<=10;k++)
    writetext("º"+k,"",9+x+k*13,14+y+j*13,Corner,ColorValue,10);
    writetext("Ͻ","",9+x+k*13,14+y+j*13,Corner,ColorValue,10);
    for(int r=0;r<=1;r++)
    writetext(""+r,"",9+x+k*13,14+y+(j-(r+1))*13,Corner,ColorValue,10);
    for(r=0;r<=1;r++)
    writetext("1"+r,"",9+x+k*13+1,14+y+(j-(r+1))*13,Corner,ColorValue,10);
}

void DeleteLogo()
{
    ObjectDelete("½");
    for(int i=0;i<=10;i++)
     ObjectDelete("Ϻ"+i);
    ObjectDelete("½");
    for(int j=0;j<=1;j++)
    ObjectDelete(""+j);
    for(j=0;j<=1;j++)
    ObjectDelete("1"+j);    
    ObjectDelete("Ͻ");
    ObjectDelete("1");
    ObjectDelete("2");
    for(int k=0;k<=10;k++)
    ObjectDelete("º"+k);
    ObjectDelete("Ͻ");
    for(int r=0;r<=1;r++)
    ObjectDelete(""+r);
    for(r=0;r<=1;r++)
    ObjectDelete("1"+r);
}